def find_path(a, b):
    path = []
    left_numerator = 0
    left_denominator = 1
    right_numerator = 1
    right_denominator = 0

    while True:
        # для удобства работают с числами в виде дробей
        if left_numerator == a and left_denominator == b:
            return ''.join(path)
        if right_numerator == a and right_denominator == b:
            return ''.join(path)

        # вычисляем среднюю дробь
        middle_numerator = left_numerator + right_numerator
        middle_denominator = left_denominator + right_denominator

        if (middle_numerator * b) < (middle_denominator * a):
            # идем вправо
            path.append('R')
            left_numerator = middle_numerator
            left_denominator = middle_denominator
        else:
            # идем влево
            path.append('L')
            right_numerator = middle_numerator
            right_denominator = middle_denominator

        # если один из крайних элементов равен, возможно выйти из цикла
        if (left_numerator == a and left_denominator == b) or (right_numerator == a and right_denominator == b):
            break

    return ''.join(path)

# Чтение входных данных
a, b = map(int, input().strip().split())

# Проверка возможности представления
import math
if math.gcd(a, b) != 1:
    print("no")
else:
    result = find_path(a, b)
    print(result)