from collections import deque, defaultdict

def guarded_warehouses(n, m, k, roads, guards):
    graph = defaultdict(list)

    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    for p, h in guards:
        queue = deque([(p, 0)]) 
        visited = set()
        while queue:
            current, distance = queue.popleft()
            if current in visited:
                continue
            visited.add(current)
            guarded.add(current)
            if distance < h: 
                for neighbor in graph[current]:
                    queue.append((neighbor, distance + 1))
    guarded = sorted(guarded)
    print(len(guarded))
    print(" ".join(map(str, guarded)))
n, m, k = map(int, input().strip().split())
roads = [tuple(map(int, input().strip().split())) for _ in range(m)]
guards = [tuple(map(int, input().strip().split())) for _ in range(k)]
guarded_warehouses(n, m, k, roads, guards)