from collections import defaultdict, deque

def find_guarded_warehouses(n, m, k, roads, guards):
    # Шаг 1: Построение графа
    graph = defaultdict(list)

    for a, b in roads:
        graph[a].append(b)
        graph[b].append(a)

    guarded = set()

    # Шаг 2: Обход графа для каждого охранника
    for p, h in guards:
        # Используем BFS для поиска охраняемых складов
        queue = deque([(p, 0)])  # узел и текущее расстояние
        visited = set([p])

        while queue:
            current, dist = queue.popleft()
            if dist > h:
                continue
            guarded.add(current)  # Добавляем текущий склад в охраняемые

            for neighbor in graph[current]:
                if neighbor not in visited:
                    visited.add(neighbor)
                    queue.append((neighbor, dist + 1))

    # Шаг 3: Сортировка охраняемых складов
    guarded_list = sorted(guarded)

    # Шаг 4: Вывод результата
    print(len(guarded_list))
    print(" ".join(map(str, guarded_list)))

# Пример использования
n, m, k = map(int, input().split())
roads = [tuple(map(int, input().split())) for _ in range(m)]
guards = [tuple(map(int, input().split())) for _ in range(k)]

find_guarded_warehouses(n, m, k, roads, guards)